/*
 * LinesSA
 * Copyright(c) 2005 boxon
 * version 0.9
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

package lines;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.rms.*;
import java.util.*;
import java.io.*;
import javax.microedition.io.*;


/**
 *
 * @author  kkimura
 * @version
 */
public class app extends MIDlet {
    static MIDlet   midlet;
    static Display  display;
    static canvas   cv;
    static int      NHighScores = 9;

    public void startApp() {
    }
    
    public void destroyApp(boolean unconditional) {
        midlet = null;
        display = null;
    }

    public app() {
        midlet = this;
        display = Display.getDisplay(this);
        cv = new canvas();
        Display.getDisplay(this).setCurrent(cv);
    }

    protected void pauseApp() {
    }
}

final class canvas extends Canvas 
    implements CommandListener {
    Command[] command = new Command[6];
    //  萔
    private final static int
        appSavedGameID =       0,
        appSavedGameVersion =  0,

        HighScoreNameLen =     (20 + 1),

        MenuSize =             22,
        LabelSize =            32,

        NColors =              7,
        Rows =                 9,
        Columns =              9,
        RemoveMin =            5,
        NThrow =               3,

        MaxScoreDigits =       5,
        MaxScoreDisplayed =    100000,

        TopBallSize =          18,
        CellXSize =            25,
        CellYSize =            25,

        NCells =               (Rows * Columns),
        Width =                (Columns * CellXSize + 1),
        Height =               (Rows * CellYSize + 1),

        LeftOffset =           9 /* ((160 - Width) / 2) */,
        TopOffset =            30 /*(MenuSize + (250 - MenuSize - Height) / 2)*/,

        HighScoreY =            24,
        HighScoreX =            100,
        HighScoreWidth =        156,
        HighScoreSpace =        4;
    private Image[] ba = new Image[7];
    private Image           bg;
    private static int      Status = 		0;
    private static int      MinHighScore = 	0;
    private static int      Selected =          -1;
    private static int[]    direction =         {Columns, 1, Columns + 1, Columns - 1};
    private static int[]    Board =             new int[NCells];
    private static int      NFree =             0;
    private static int      StatusShowNext =    0x01;
    private static int      Score =   		0;
    private static int[]    NextColor =         new int[NThrow];
    private static int[]    HScores =           new int[app.NHighScores];
    private static Random   rand =              new Random();
    private static int      CurPos =            41;
    private static boolean  up = true;
    
    private Image       imgOff;
    private Graphics    graOff;
    
    private static boolean  doing =             false;
    
    canvas() {
        init();
    }
    
    protected void paint(Graphics g) {
        if (doing) return;
        doing = true;
        
        //  ItC[W̍쐬
        if (imgOff == null || imgOff.getHeight() != getHeight()) {
            imgOff = Image.createImage(getWidth(),getHeight());
            graOff = imgOff.getGraphics();
        }
        
        graOff.setColor(255,255,255);
        graOff.fillRect(0,0,getWidth(),getHeight());
        
        DrawBoard();
        
        if (NFree > 0) {
            DrawCursor();
            DrawSelection();
        }
        
        //  ʂɔf
        g.drawImage(imgOff, 0, 0, g.LEFT|g.TOP);
        
        doing = false;
    }

    protected void keyPressed(int keyCode) {
        if (keyCode==0) {
            super.keyPressed(keyCode);
            return;
        }
        boolean bRepaint = true;
        switch (getGameAction(keyCode)) {
            case LEFT:
            case KEY_NUM4:
                if ((CurPos % Columns) > 0) 
                    CurPos--; 
                else
                    CurPos += (Columns - 1);
                break;
            case RIGHT:
            case KEY_NUM6:
                if ((CurPos % Columns) < Columns - 1) 
                    CurPos++; 
                else
                    CurPos -= (Columns - 1); 
                break;
            case UP:
            case KEY_NUM2:
                if (CurPos > Columns - 1) 
                    CurPos -= Columns; 
                else
                    CurPos += Columns*(Rows - 1);
                break;
            case DOWN:
            case KEY_NUM8:
                if (CurPos < Columns*(Rows - 1)) 
                    CurPos += Columns; 
                else
                    CurPos -= Columns*(Rows - 1);
                break;
            case FIRE:
            case KEY_NUM5:
                if (SelectAllowed(CurPos)) {
                    up = false;
                    bRepaint = SelectBall(CurPos);
                }
        }
        if (bRepaint) {
            repaint();
            up = true;
        }
        super.keyPressed(keyCode);
    }

    protected void keyRepeated(int keyCode) {
        keyPressed(keyCode);
    }
    
    private void init() {
        command[0] = new Command("f", Command.ITEM, 1);
        command[1] = new Command("VK", Command.ITEM, 1);
        command[2] = new Command("̃{[\/\", Command.ITEM, 1);
        command[3] = new Command("nCXRA", Command.ITEM, 1);
        command[4] = new Command("SLOQ(f)", Command.ITEM, 1);
        command[5] = new Command("o[W", Command.ITEM, 1);
        
        addCommand(command[0]);
        addCommand(command[1]);
        addCommand(command[2]);
        addCommand(command[3]);
        addCommand(command[4]);
        addCommand(command[5]);

        setCommandListener(this);

        try {
            bg=Image.createImage("/res/bg.png");
            for (int n=0; n<7; ++n)
                ba[n]=Image.createImage("/res/b"+Integer.toString(n+1)+".png");
        } catch (Exception e) {
        }
        InitBoard();
        LoadData();
        
        InitHighScores();
        Status |= StatusShowNext;
    }

    private void SetBoard(int n, int c)
    {
        Board[n] = c;
    }

    private void InitHighScores()
    {
        for (int n = 0; n < app.NHighScores; ++n) {
            HScores[n] = -1;
        }
        RecordStore rs = null;
        RecordEnumeration re = null;
        HiScoreComparator rc = null;
        int Sc;
        String sData;
        byte[] w = null;
        try {
            rs = RecordStore.openRecordStore("HiScores", true);
            int n = 0;
            int pos;
            if (rs.getNumRecords() > 0) {
                rc = new HiScoreComparator();
                re = rs.enumerateRecords(null, rc, true);
                while (re.hasNextElement()) {
                    w = re.nextRecord();
                    sData = new String(w);
                    pos = sData.indexOf(",");
                    Sc = Integer.parseInt(sData.substring(0, pos));
                    HScores[n] = Sc;
                    n++;
                    if (n > app.NHighScores - 1) break;
                }
            }
            rs.closeRecordStore();
        } catch (Exception e) {
            try {
                if (rs != null) rs.closeRecordStore();
            } catch (Exception e2) {
            }
        }
        MinHighScore = HScores[app.NHighScores - 1];
    }

    static boolean GotHighScore(int score)
    {
	return (score > MinHighScore);
    }

    private void InitColors()
    {
        int i;

        for (i = 0; i < NThrow; i++) {
            NextColor[i] = (rand.nextInt()>>>1) % NColors;
        }
    }

    static int GetColor()
    {
        int i, c;

        c = NextColor[0];

        for (i = 0; i < NThrow - 1; i++) {
                NextColor[i] = NextColor[i + 1];
        }

        NextColor[NThrow - 1] = (rand.nextInt()>>>1) % NColors;

        return c;
    }

    private void DrawScore()
    {
        String msg = new String("Score:");
        Score %= MaxScoreDisplayed;
        msg += Score;
        
        graOff.setColor(0, 0, 0);
        graOff.drawString(msg, 16, 260, graOff.LEFT|graOff.TOP);
    }

    private void DrawCursor()
    {
        int pos = CurPos;
        int x = LeftOffset + pos % Columns * CellXSize;
        int y = TopOffset  + pos / Columns * CellYSize;
        int w = CellXSize - 1;
        int h = CellYSize - 1;

        graOff.setColor(0, 0, 0);
        graOff.drawRect(x, y, w, h);

        if (Board[pos] > -1 && Selected != pos) {
            x = LeftOffset + pos % Columns * CellXSize + 2;
            if (up)
                y = TopOffset  + pos / Columns * CellYSize - 2;
            else
                y = TopOffset  + pos / Columns * CellYSize + 2;
            graOff.drawImage(ba[Board[pos]], x, y, graOff.LEFT|graOff.TOP);
        }
    }
    
    private void DrawSelection()
    {
        int pos = Selected;
        if (pos < 0) return;
        
        int x = LeftOffset + pos % Columns * CellXSize + 1;
        int y = TopOffset  + pos / Columns * CellYSize + 1;

        graOff.setColor(255, 0, 0);
        graOff.drawRect(x, y, CellXSize - 3, CellYSize - 3);        
        graOff.setColor(230, 230, 200);
        graOff.fillRect(x + 1, y + 1, CellXSize - 4, CellYSize - 4);        

        if (Board[pos] > -1) {
            x = LeftOffset + pos % Columns * CellXSize + 2;
            y = TopOffset  + pos / Columns * CellYSize + 2;
            graOff.drawImage(ba[Board[pos]], x, y, graOff.LEFT|graOff.TOP);
        }
    }

    private void DrawBall(int pos)
    {
        if (pos == CurPos && NFree > 0) return;
        if (pos == Selected && NFree > 0) return;
        int x = LeftOffset + pos % Columns * CellXSize + 2;
        int y = TopOffset  + pos / Columns * CellYSize + 2;
        graOff.drawImage(ba[Board[pos]], x, y, graOff.LEFT|graOff.TOP);
    }

    private void DrawTopBall(int c, int x, int y)
    {
        graOff.drawImage(ba[c], x, y, graOff.LEFT|graOff.TOP);
    }

    private void DrawFrame()
    {
        graOff.drawImage(bg, 0, 0, graOff.LEFT | graOff.TOP);
    }

    private void DrawTopBalls()
    {
        for (int i = 0; i < NThrow; i++) {
            DrawTopBall(NextColor[i],  
                        85 + i * CellXSize, 
                        4);
        }
    }

    private void ReDrawStatus()
    {
        int x = LabelSize;
        int y = 0;
        int w = Width + 1;
        int h = MenuSize - 1;

        DrawScore();
        if ((Status & StatusShowNext) > 0)
            DrawTopBalls();

        if (NFree <= 0) {
            Font f;
            f = Font.getDefaultFont();
            w = f.stringWidth("Q[I[o[") + 20;
            y = (Height - 10) / 2;
            x = (Width - w) / 2;
            graOff.setColor(255, 255, 255);
            graOff.fillRoundRect(x, y, w, h, 10, 10);
            graOff.setColor(0, 0, 0);
            graOff.drawRoundRect(x, y, w, h, 10, 10);
            graOff.drawString("Q[I[o[", x + 10, y + 4, graOff.LEFT|graOff.TOP);
        }
    }

    final static int MovesMax =    127;
    static int[] Moves = new int[NCells];

    private void BuildMovesArray(int pos)
    {
        int i, d, found = 1;

        for (i = 0; i < NCells; i++)
            Moves[i] = Board[i] >= 0 ? -1 : MovesMax;

        Moves[pos] = 0;

        for (d = 0; found == 1; d++) {
            found = 0;
            for (i = 0; i < NCells; i++) {
                if (Moves[i] == d) {
                    found = 1;
                    if (i % Columns > 0 && Moves[i - 1] > d + 1)
                        Moves[i - 1] = d + 1;
                    if (i % Columns < Columns - 1 && Moves[i + 1] > d + 1)
                        Moves[i + 1] = d + 1;
                    if (i >= Columns && Moves[i - Columns] > d + 1)
                        Moves[i - Columns] = d + 1;
                    if (i < Columns * (Rows - 1) && Moves[i + Columns] > d + 1)
                        Moves[i + Columns] = d + 1;
                }
            }
        }
    }

    private boolean SelectAllowed(int pos)
    {
        if (Selected == pos)
            return false;

        if (Board[pos] >= 0) /* You can select a ball anytime */
            return true;

        if (Selected >= 0 && Moves[pos] < MovesMax)
            return true;

        return false;
    } 

    private void MoveBall(int pos)
    {
        int d = Moves[pos] - 1;
        int c = Board[Selected];
        int i;

        BuildMovesArray(pos);
        i = Selected; 
        Selected = -1;	

        for (; i != pos; d--) {
            SetBoard(i, -1);	
            if (i >= Columns && Moves[i - Columns] == d) 
                i = i - Columns;
            else if (i < Columns * (Rows - 1) && Moves[i + Columns] == d)
                i = i + Columns;
            else if (i % Columns > 0 && Moves[i - 1] == d)
                i--;
            else if (i % Columns < Columns - 1 && Moves[i + 1] == d)
                i++;
            else 
                ShowAlert("MoveBall: no moves");

            SetBoard(i, c);	
            DrawBall(i);
            delay(5);
        }
    }

    private void ShowAlert(String message) {
        Alert alert = new Alert("Error", message, null, AlertType.WARNING);
        alert.setTimeout(Alert.FOREVER);
        (Display.getDisplay(app.midlet)).setCurrent(alert);
    }
    private void RemoveBall(int pos)
    {
        if (Board[pos] < 0)
            ShowAlert("RemoveBall: no ball");
        SetBoard(pos, -1);
        NFree++;
    }

    private boolean CheckBall(int cpos, int npos, int color)
    {
        int deltaX, deltaY;

        if (npos >= 0 && npos < NCells) {
            deltaX = npos % Columns - cpos % Columns;
            deltaY = npos / Columns - cpos / Columns;
            if (deltaX * deltaX + deltaY * deltaY <= 2 && Board[npos] == color)
                return true;
        }
        return false;
    }

    private int CheckDirection(int pos, int delta, boolean remove)
    {
        int i, n, c;

        c = Board[pos];
        n = 1;

        for (i = pos; CheckBall(i, i - delta, c); i -= delta, n++)
            if (remove) 
                RemoveBall(i - delta);

        for (i = pos; CheckBall(i, i + delta, c); i += delta, n++)
            if (remove) 
                RemoveBall(i + delta);

        return n;
    }

    private int CheckBalls(int pos, boolean addscore)
    {
        int lines = 0;
        int total = 0;
        int i, n;

        for (i = 0; i < 4; i++) {
            n = CheckDirection(pos, direction[i], false);
            if (n >= RemoveMin) {
                total += n;
                lines++;
                CheckDirection(pos, direction[i], true);
            }
        }

        if (lines > 0) {
            RemoveBall(pos);
            if (addscore) {
                n = lines + total - 1 - RemoveMin;
                Score += 10 + 2 * n * n;
            }
        }

        return lines;
    }

    private int ThrowBalls(int  n)
    {
        int i, j;

        for (; (n-- > 0) && (NFree > 0); i++, NFree--) {
            j = (rand.nextInt()>>>1) % NFree;

            for (i = 0; i < NCells; i++) 
                if (Board[i] < 0 && --j < 0)
                    break;

            SetBoard(i, GetColor());
            DrawBall(i);
            delay(200);
            CheckBalls(i, false);
        }
        return NFree;	
    }

    private void DrawBoard()
    {
        int i;

        DrawFrame();

        if (NFree == NCells) {
            ThrowBalls(5); /* New Game */
        } else {
            for (i = 0; i  < NCells; i++)
                if (Board[i] >= 0) 
                    DrawBall(i);
        }
        ReDrawStatus();		
    }

    private void InitBoard()
    {
        int i;

        Selected = -1;

        for (i = 0; i < NCells; i++)
            SetBoard(i, -1);

        NFree = NCells;
        Score = 0;
        InitColors();
    }

    private boolean SelectBall(int pos)
    {
        if (Board[pos] >= 0) { /* User selected a ball */

            if (Selected >= 0) {
                if (Board[Selected] < 0)
                    ShowAlert("SelectBall: no ball");
            }
            Selected = pos;
            BuildMovesArray(pos);
            return true;
        }

        MoveBall(pos);
        Selected = -1;

        int hit = CheckBalls(pos, true);
        if (hit == 0)
            ThrowBalls(3);

        while(NFree == NCells)
            ThrowBalls(3);

        if (NFree <= 0) {
            if (GotHighScore(Score)) {
                int HiScore = Score;
                (Display.getDisplay(app.midlet)).setCurrent(new newscore(HiScore));
                InitBoard();
                SaveData();
            }
            return true;
        } else {
            return hit == 0? false: true;
        }
    }

    private void EraseScoreBoard()
    {
        int x = HighScoreSpace;
        int y = HighScoreY + 1;
        int w = HighScoreWidth;
        int h = 114;

        graOff.setColor(255, 255, 255);
        graOff.fillRect(x, y, w, h);
    }

    private void DrawScoreBoard()
    {
    }
    
    private void delay(int msec) {
        repaint();
        serviceRepaints();
        try {
            Thread.currentThread().sleep(msec);
        } catch(InterruptedException ignore) { }
    }

    public void commandAction(Command c, Displayable disp) {
        if (c == command[1]) {          // New
            InitBoard();
            DrawBoard();
            repaint();
            serviceRepaints();
        } else if (c == command[0]) {   // Save
            SaveData();
            app.midlet.notifyDestroyed();
        } else if (c == command[2]) {   // Show/Hide Next Balls
            Status ^= StatusShowNext;
            ReDrawStatus();
        } else if (c == command[3]) {   //  High Scores
            (Display.getDisplay(app.midlet)).setCurrent(new sccanvas(-1));
        } else if (c == command[4]) {   //  Ranking
            ShowRanking();
        } else if (c == command[5]) {   //  About
            (Display.getDisplay(app.midlet)).setCurrent(new about());
        }
    }

    private void ShowRanking() {
        try {
            boolean ret = app.midlet.platformRequest("http://www.kumisuke.jp/boxon/php/sclines.php");
            SaveData();
            //app.display.setCurrent(null);
            app.midlet.notifyDestroyed();
        } catch (Exception e) {
        }
    }
    private void ShowMessage(String caption, String message) {
        Alert alert = new Alert(caption, message, null, AlertType.INFO);
        alert.setTimeout(Alert.FOREVER);
        (Display.getDisplay(app.midlet)).setCurrent(alert);
    }
    
    private void SaveData() {
        RecordStore rs = null;
        try {
            try {
                RecordStore.deleteRecordStore("LinesSA");
            } catch (Exception e) {
            }
            rs = RecordStore.openRecordStore("LinesSA", true);

            byte[] w = new byte[1+NThrow+NCells+4+1];
            int p = 0;
            byte b;
            w[p++] = (byte)CurPos;
            for (int n=0; n < NThrow; ++n) {
                b = (byte)NextColor[n];
                w[p++] = b;
            }
            for (int n=0; n < NCells; ++n) {
                if (Board[n] == -1)
                    b = (byte)0xff;
                else
                    b = (byte)Board[n];
                w[p++] = b;
            }
            w[p++] = (byte)((Score>>24)&0xff);
            w[p++] = (byte)((Score>>16)&0xff);
            w[p++] = (byte)((Score>>8)&0xff);
            w[p] = (byte)((Score)&0xff);
            
            rs.addRecord(w, 0, w.length);
            
            rs.closeRecordStore();
        } catch (Exception e) {
            try {
                if (rs != null) rs.closeRecordStore();
            } catch (Exception e2) {
            }
            ShowAlert("R[hXgȀ݂Ɏs܂B");
        }
    }

    private void LoadData() {
        RecordStore rs = null;
        RecordEnumeration re = null;
        byte[] w = null;
        try {
            rs = RecordStore.openRecordStore("LinesSA", false);
            if (rs.getNumRecords() == 0) {
                return;
            }
            re = rs.enumerateRecords(null, null, true);
            if (!re.hasNextElement()) return;
            w = re.nextRecord();

            int p = 0;
            int i;
            CurPos = (int)w[p++];
            for (int n=0; n < NThrow; ++n) {
                NextColor[n] = (int)w[p++];
            }
            for (int n=0; n < NCells; ++n) {
                i = (int)w[p++];
                Board[n] = i;
                if (i >= 0) 
                    NFree--;
            }
            Score = ((w[p]&0xff)<<24)+
                        ((w[p+1]&0xff)<<16)+
                        ((w[p+2]&0xff)<<8)+
                        ((w[p+3]&0xff));
            
            rs.closeRecordStore();
        } catch (Exception e) {
            try {
                if (rs != null) {
                    rs.closeRecordStore();
                }
            } catch (Exception e2) {
            }
            ShowAlert("R[hXgA̓ǂݍ݂Ɏs܂B");
        }
    }
}

final class sccanvas extends Canvas 
    implements CommandListener {
    private Image       imgOff;
    private Graphics    graOff;
    private int         intTop = -1;
    private int         rank;
    private boolean     msg = false;

    sccanvas(int r) {
        rank = r;
        if (rank == 1) msg = true;
        Command cOk = new Command("OK", Command.SCREEN, 0);
        Command cReg = new Command("LOo^", Command.SCREEN, 0);
        Command cClear = new Command("NA", Command.SCREEN, 0);
        addCommand(cOk);
        addCommand(cReg);
        addCommand(cClear);
        setCommandListener(this);
    }

    protected void paint(Graphics g) {
        if (imgOff == null || imgOff.getHeight() != getHeight()) {
            imgOff = Image.createImage(getWidth(),getHeight());
            graOff = imgOff.getGraphics();
        }
        
        int y;
        int wScore;
        int wDate;
        int wNo;
        int[] HiScore = new int[app.NHighScores];
        
        HiScore[0] = 1200;
        HiScore[1] = 600;
        HiScore[2] = 30;
        Font f = Font.getDefaultFont();
        y = f.getHeight() + 2;
        graOff.setColor(100, 100, 100);
        graOff.fillRect(0, 0, imgOff.getWidth(), y);
        graOff.setColor(255, 255, 255);
        graOff.drawString("nCXRA", imgOff.getWidth() / 2, 1, graOff.HCENTER|graOff.TOP);
        y += f.getHeight() + 1;
        graOff.setColor(0, 0, 0);
        wNo = f.stringWidth("00.");
        wScore = imgOff.getWidth() - f.stringWidth("0000000");
        graOff.setFont(f);
        graOff.drawString("O", wNo + 4, y - 1, graOff.LEFT|graOff.BOTTOM);
        graOff.drawString("_", imgOff.getWidth() - 4, y - 1, graOff.RIGHT|graOff.BOTTOM);
        graOff.drawLine(0, y - 1, imgOff.getWidth(), y - 1);

        RecordStore rs = null;
        RecordEnumeration re = null;
        HiScoreComparator rc = null;
        int Sc;
        String Name;
        String sData;
        byte[] w = null;
        try {
            rs = RecordStore.openRecordStore("HiScores", true);
            int n = 0;
            int pos;
            if (rs.getNumRecords() > 0) {
                rc = new HiScoreComparator();
                re = rs.enumerateRecords(null, rc, true);
                if (!re.hasNextElement()) return;
                w = re.nextRecord();
                while (w != null) {
                    sData = new String(w);
                    pos = sData.indexOf(",");
                    Sc = Integer.parseInt(sData.substring(0, pos));
                    if (intTop < 0) intTop = Sc;
                    Name = sData.substring(pos + 1);
                    if (n + 1 == rank) {
                        graOff.setColor(0, 0, 255);
                    } else {
                        graOff.setColor(0, 0, 0);
                    }
                    graOff.drawString(Integer.toString(n + 1)+".", wNo, y, graOff.RIGHT|graOff.TOP);
                    graOff.drawString(Name, wNo + 4, y, graOff.LEFT|graOff.TOP);
                    graOff.drawString(Integer.toString(Sc), imgOff.getWidth() - 4, y, graOff.RIGHT|graOff.TOP);
                    y += f.getHeight() + 4;

                    w = re.nextRecord();
                    n++;
                }
            }
            rs.closeRecordStore();
        } catch (Exception e) {
            try {
                if (rs != null) rs.closeRecordStore();
            } catch (Exception e2) {
            }
        }
        if (msg) {
            Font fs = Font.getFont(f.getFace(), Font.STYLE_BOLD, Font.SIZE_SMALL);
            int sh = f.getHeight() + 5;
            y = (imgOff.getHeight() - sh * 2) / 2;
            int x = imgOff.getWidth() / 2;
            int sw = f.stringWidth("LOo^R}h") + 20;
            
            graOff.setColor(200, 200, 200);
            graOff.fillRect((imgOff.getWidth() - sw) / 2, y, sw, sh * 4 + 20);
            graOff.setColor(100, 100, 100);
            graOff.drawRect((imgOff.getWidth() - sw) / 2, y, sw, sh * 4 + 20);
            graOff.setColor(0, 0, 0);
            graOff.setFont(f);
            graOff.drawString("nCXRAXV!!", x, y + 10, graOff.HCENTER|graOff.TOP);
            graOff.drawString("LOo^R}h", x, y + 10 + sh, graOff.HCENTER|graOff.TOP);
            graOff.drawString("SLOɓo^!!", x, y + 10 + sh*2, graOff.HCENTER|graOff.TOP);
            graOff.setFont(fs);
            graOff.setColor(100, 0, 0);
            graOff.drawString("(pPbgオ܂)", x, y + 10 + sh*3, graOff.HCENTER|graOff.TOP);
            msg = false;
        }
        g.drawImage(imgOff, 0, 0, g.LEFT|g.TOP);
    }

    private void ClearHiScores() {
        RecordStore rs = null;
        int num;
        try {
            rs = RecordStore.openRecordStore("HiScores", false);
            num = rs.getNumRecords();
            rs.closeRecordStore();
            if (num > 0) {
                rs.deleteRecordStore("HiScores");
            }
        } catch (Exception e) {
            try {
                if (rs != null) {
                    rs.closeRecordStore();
                }
            } catch (Exception e2) {
            }
        }
        
    }
    public void commandAction(Command c, Displayable displayable) {
        if (c.getLabel().toString() == "NA") {
            ClearHiScores();
            repaint();
        } else if (c.getLabel().toString() == "LOo^") {
            (Display.getDisplay(app.midlet)).setCurrent(new regrecord(intTop));
        } else {
            (Display.getDisplay(app.midlet)).setCurrent(app.cv);
        }
    }

    protected void keyPressed(int keyCode) {
        repaint();
    }
}

final class newscore extends Form 
    implements CommandListener {
    private Image       imgOff;
    private Graphics    graOff;
    private TextField   tfName;
    private int         Score;

    newscore(int sc) {
        super("O");
        Command c = new Command("OK", Command.SCREEN, 0);
        addCommand(c);
        setCommandListener(this);
        
        Score = sc;
        StringItem si = new StringItem("XRA", Integer.toString(Score));
        append(si);
        tfName = new TextField("[U", "owner", 30, TextField.ANY);
        append(tfName);
    }

    public void commandAction(Command c, Displayable displayable) {
        int rank = UpdateHiScores();
        (Display.getDisplay(app.midlet)).setCurrent(new sccanvas(rank));
    }
    
    private int UpdateHiScores() {
        RecordStore rs = null;
        RecordEnumeration re = null;
        HiScoreComparator rc = null;
        byte[] w = null;
        int id;
        int rank = -1;
        int nScore;
        try {
            rs = RecordStore.openRecordStore("HiScores", true);
            nScore = rs.getNumRecords();
            int[] Sc = new int[nScore + 1];
            Sc[nScore] = -1;
            String[] Name = new String[nScore];
            String sData;
            int n = 0;
            int pos;
            if (nScore > 0) {
                rc = new HiScoreComparator();
                re = rs.enumerateRecords(null, rc, true);
                while (re.hasNextElement()) {
                    id = re.nextRecordId();
                    w = rs.getRecord(id);
                    sData = new String(w);
                    pos = sData.indexOf(",");
                    Sc[n] = Integer.parseInt(sData.substring(0, pos));
                    Name[n] = sData.substring(pos + 1);
                    rs.deleteRecord(id);
                    n++;
                }
            }
            for (int index = 0; index < app.NHighScores; ++index) {
                if (Sc[index] < Score) {
                    rank = index + 1;
                    w = (Integer.toString(Score)+","+tfName.getString()).getBytes();
                    rs.addRecord(w, 0, w.length);
                    Score = -1;
                }
                if (index > nScore - 1) break;
                w = (Integer.toString(Sc[index])+","+Name[index]).getBytes();
                rs.addRecord(w, 0, w.length);
            }
            rs.closeRecordStore();
        } catch (Exception e) {
            try {
                if (rs != null) rs.closeRecordStore();
            } catch (Exception e2) {
            }
        }
        return rank;
    }
}

final class regrecord extends Form 
    implements CommandListener {
    private Image       imgOff;
    private Graphics    graOff;
    private TextField   tfName;
    private TextField   tfKey;
    private TextField   tfComment;
    private StringItem  siRes;
    private int         Score;

    regrecord(int sc) {
        super("LOo^");
        Command c1 = new Command("o^", Command.SCREEN, 0);
        addCommand(c1);
        Command c2 = new Command("", Command.SCREEN, 0);
        addCommand(c2);
        setCommandListener(this);
        
        Score = sc;
        StringItem si = new StringItem("XRA", Integer.toString(Score));
        append(si);
        tfName = new TextField("o^[U", "", 30, TextField.ANY);
        append(tfName);
        tfKey = new TextField("[Uʕ(J)", "", 30, TextField.ANY);
        append(tfKey);
        tfComment = new TextField("Rg", "", 30, TextField.ANY);
        append(tfComment);
        siRes = new StringItem("Xe[^X", "");
        append(siRes);
        LoadParams();
    }

    public void commandAction(Command c, Displayable displayable) {
        if (c.getLabel().equals("o^")) {
            if (tfName.getString().length() > 0 && tfKey.getString().length() > 0) {
                Thread thread = new Thread() {
                    public void run() {
                        siRes.setText(sendMessage());
                    }
                };
                thread.start();
                return;
            } else {
                siRes.setText("o^[Uƃ[Uʕ͕K{ڂł");                
            }
        } else {
            (Display.getDisplay(app.midlet)).setCurrent(new sccanvas(-1));
        }
    }
    
    //
    //  LOo^B̃\[XŃLOo^@łc
    //
    String sendMessage(){
        String res = "";
        try {
            //  bZ[W̏
            String message ="p="+tfName.getString()+"&l="+tfKey.getString()+"&c="+tfComment.getString()+"&s="+Integer.toString(Score);
            String url = "http://www.kumisuke.jp/boxon/php/reglines.php?"+message;

            //  ʐMIuWFNg̐Ɛݒ
            siRes.setText("o^Jn");
            //HttpConnection con = (HttpConnection)Connector.open("http://localhost/mainweb/httpcheck.aspx", Connector.READ_WRITE);
            HttpConnection con = (HttpConnection)Connector.open(url, Connector.READ);
            con.setRequestMethod(HttpConnection.GET);

            //X|X󂯎
            DataInputStream in = con.openDataInputStream();
            int input;
            while((input = in.read())!=-1){
                res = res +(char)input;
            }
            in.close();

            //ڑ
            con.close();
            
            if (res.startsWith("0")) {
                res = "VKo^";
            } else if (res.startsWith("1")) {
                res = "XRAXV";
            } else if (res.startsWith("9")) {
                res = "G[";
            } else {
                res = "\ʃG[";
            }
        } catch (Exception e) {
            res = "ʐMG[Bڑ悪 CLUB AIR-EDGE ̏ꍇɂ̓LOo^ł܂B";
        }
        SaveParams();
        return res;
    }
    
    //  ݒǂݍ
    private void LoadParams() {
        RecordStore rs = null;
        RecordEnumeration re = null;
        byte[] w = null;
        try {
            rs = RecordStore.openRecordStore("RegParams", false);
            int num = rs.getNumRecords();
            if (num == 0) {
                return;
            }
            re = rs.enumerateRecords(null, null, true);
            if (!re.hasNextElement()) return;
            
            //  ݒf[^̎擾
            w = re.nextRecord();
            ByteArrayInputStream bais = new ByteArrayInputStream(w);
            DataInputStream in = new DataInputStream(bais);
            try{
                tfName.setString(in.readUTF());
                tfKey.setString(in.readUTF());
                tfComment.setString(in.readUTF());
            }catch(Exception e){
            }
            
            //  Xg[
            in.close();
            bais.close();

            //  R[hXgA
            rs.closeRecordStore();
        } catch (Exception e) {
            try {
                if (rs != null) {
                    rs.closeRecordStore();
                }
            } catch (Exception e2) {
            }
        }      
    }
    
    private void SaveParams() {
        RecordStore rs = null;
        boolean bSuccess = true;
        try {
            try {
                RecordStore.deleteRecordStore("RegParams");
            } catch (Exception e) {
            }
            rs = RecordStore.openRecordStore("RegParams", true);
            
            //  ԃf[^̕ۑ
            byte[] sdata = null;
            try{
                ByteArrayOutputStream baos = new ByteArrayOutputStream();
                DataOutputStream out = new DataOutputStream(baos);

                //  ݒo
                out.writeUTF(tfName.getString());
                out.writeUTF(tfKey.getString());
                out.writeUTF(tfComment.getString());

                //  oCg𐶐
                sdata = baos.toByteArray();
                baos.close();
                out.close();

            }catch(Exception e){
            }
            rs.addRecord(sdata, 0, sdata.length);
            
            //  R[hXgA
            rs.closeRecordStore();
        } catch (Exception e) {
            bSuccess = false;
            try {
                if (rs != null) rs.closeRecordStore();
            } catch (Exception e2) {
            }
        }
    }
}

final class about extends Canvas 
    implements CommandListener {
    private Image       imgOff;
    private Graphics    graOff;

    about() {
        Command c = new Command("OK", Command.SCREEN, 0);
        addCommand(c);
        setCommandListener(this);
    }

    protected void paint(Graphics g) {
        //  ItC[W̍쐬
        if (imgOff == null || imgOff.getHeight() != getHeight()) {
            imgOff = Image.createImage(getWidth(),getHeight());
            graOff = imgOff.getGraphics();
        }
        
        int x;
        int y;
        String str;
        Font f = Font.getFont(Font.FACE_PROPORTIONAL, Font.STYLE_PLAIN, Font.SIZE_LARGE);
        graOff.setFont(f);
        str = "LinesSA";
        x = (imgOff.getWidth() - f.stringWidth(str)) / 2;
        y = (imgOff.getHeight() - 100) / 2;
        graOff.setColor(0, 0, 0);
        graOff.drawString(str, x, y, graOff.LEFT|graOff.TOP);
        y += f.getHeight() + 20;
        f = Font.getDefaultFont();
        graOff.setFont(f);
        x = imgOff.getWidth() / 2;
        graOff.drawString("o[W " + app.midlet.getAppProperty("MIDlet-Version"), x, y, graOff.HCENTER|graOff.TOP); y += f.getHeight() + 10;
        graOff.drawString("Copyright(c)2005-2006", x, y, graOff.HCENTER|graOff.TOP); y += f.getHeight() + 4;
        graOff.drawString("boxon", x, y, graOff.HCENTER|graOff.TOP); y += f.getHeight() + 4;
        graOff.drawString("boxon@kumisuke.jp", x, y, graOff.HCENTER|graOff.TOP); y += f.getHeight() + 10;
        graOff.drawString("t[EFA", x, y, graOff.HCENTER|graOff.TOP);
        
        //  ʂɔf
        g.drawImage(imgOff, 0, 0, g.LEFT|g.TOP);
    }

    public void commandAction(Command c, Displayable displayable) {
        (Display.getDisplay(app.midlet)).setCurrent(app.cv);
    }
}

//
//  nCXRAёւ
//
final class HiScoreComparator implements RecordComparator {
    //  R[hr
    public int compare(byte[] rec1, byte[] rec2) {
        int pos;

        String sData1 = new String(rec1);
        pos = sData1.indexOf(",");
        int sc1 = Integer.parseInt(sData1.substring(0, pos));

        String sData2 = new String(rec2);
        pos = sData2.indexOf(",");
        int sc2 = Integer.parseInt(sData2.substring(0, pos));

        if(sc1 == sc2){
            return RecordComparator.EQUIVALENT;
        }else if(sc1 > sc2){
            return RecordComparator.PRECEDES;
        }else {
            return RecordComparator.FOLLOWS;
        }
    }
}

